# Temporal Addon
# by plushpuffin
# plushpuffin@wwddfd.com
# http://www.wwddfd.com
#
# corrections by plushpuffin
#
# Please note that you do not have to use a dash symbol in DD-MM-YYYY
# You may use any non-digit(s) to separate the three numbers
#
push(@Addons_Loaded, 'Temporal 1.3');
push(@Addons_RemoveNews, 'Temporal_FormFields');
push(@Addons_RemoveNewsSave, 'Temporal_RemoveNewsSave');
push(@Addons_DisplaySubForm, 'Temporal_FormFields');
unshift(@Addons_SaveNews, 'Temporal_SaveNews');
push(@Addons_SaveNews_3, 'Temporal_SaveNews_3');
&CheckBuild(3, "Temporal 1.3", "npa_temporal.pl");

$Addons_List{'Temporal 1.3'} = ['npa_temporal.pl', q~Change newsitem date and/or time. by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a> - <b><a href="http://www.wwddfd.com">plushpuffin's perl garden</a></b>~];


sub Temporal_SaveNews {
	if ($in{'news_date'} || $in{'news_time'}) {
		# Generate news ID
		my $dertime = Temporal_MakeDate($in{'news_date'},$in{'news_time'},time);
		unless ($dertime) { NPdie("No time!"); }
		$rando = int(rand(99999));
		$newsid = join(',', $dertime, $rando, $newscat);
		$snid = join(',', $dertime, $rando, '');
		# Ensure news ID is not already being used.
		while ($NewsID{$snid} ne '') {
			$rando = int(rand(99999));
			$newsid = join(',', $dertime, $rando, $newscat);
			$snid = join(',', $dertime, $rando, '');
		}
	}
}

sub Temporal_FormFields {
	push(@formfields, 'news_date');
	$FormFieldsName{'news_date'} = 'Change date? (or leave blank) (DD-MM-YYYY)';
	push(@formfields, 'news_time');
	$FormFieldsName{'news_time'} = 'Change [military] time? (or leave blank) (HH:MM:SS)';
}

sub Temporal_SaveNews_3 {
	if ($in{'news_time'} || $in{'news_date'}) {
		# Load news database again.
		loadND();
		# Generate array of dates.
		my @ntime; 
		my $iter;
		foreach $iter (@NewsData) {
			push(@ntime, $iter->{'newstime'});
		}
		# Sort!
		@NewsData = @NewsData [ sort { $ntime[$a] <=> $ntime[$b] } 0 .. $#ntime];
		# Save!
		saveND();
		# The End
	}
}

sub Temporal_RemoveNewsSave {
	my ( $nn, $MDdertime, $MDrando, $MDnewsid, $MDsnid );
	$nnCMD = 0;
	for( $nn = 0; $nn < $totnewsnum; $nn++ ) {
		$chknum = "chk--$nn";
		if ($in{$chknum} eq 'remove') { next; }
		unless ($DisableModify{$i} != 1 && ($DisableModify{$i} != 2 || $up > 1)) { next; }
		if ($in{"news_date--$nn"} || $in{"news_time--$nn"} ) {
			# Generate news ID
			$MDdertime = Temporal_MakeDate($in{"news_date--$nn"},$in{"news_time--$nn"},$NewsData[$nn]->{'newstime'});
			unless ($MDdertime) { NPdie('No date/time!'); }
			$MDrando = int(rand(99999));
			$MDnewsid = join(',', $MDdertime, $MDrando, $NewsData[$nn]->{'newscat'});
			$MDsnid = join(',', $MDdertime, $MDrando, '');
			# Ensure news ID is not already being used.
			while ($NewsID{$MDsnid} ne '') {
				$MDrando = int(rand(99999));
				$MDnewsid = join(',', $MDdertime, $MDrando, $NewsData[$nn]->{'newscat'});
				$MDsnid = join(',', $MDdertime, $MDrando, '');
			}
			$Temporal_Mod{$NewsData[$nn]->{'newsid'}} = $MDsnid;
			$NewsData[$nn]->{'newstime'} = $MDdertime;
			$NewsData[$nn]->{'newsid'} = $MDsnid;
			$NewsData[$nn]->{'newsrand'} = $MDrando;
			$ChangedItems{$nn} = 1;
			$nnCMD ||= 1 + $nn;
			$nnCID ||= $NewsData[$nn]->{'newsid'};
		}
	}
	if( $nnCMD ) {
		unshift(@Addons_RemoveNewsSave_2, 'Temporal_RemoveNewsSave_2');
	}
}

sub Temporal_RemoveNewsSave_2 {
	# Load news database again.
	if( $NewsData[$nnCMD-1]->{'newsid'} ne $nnCID ) {
		loadND();
	}
	foreach (keys %ChangedItems) {
		push( @Temporal_Modified, $NewsData[$_]->{'newsid'} );
	}
	# Generate array of dates.
	my @ntime; 
	my $iter;
	foreach $iter (@NewsData) {
		push(@ntime, $iter->{'newstime'});
	}
	# Sort!
	@NewsData = @NewsData [ sort { $ntime[$a] <=> $ntime[$b] } 0 .. $#ntime];
	# Save!
	saveND();
	loadND();
	%ChangedItems = ();
	foreach (@Temporal_Modified) {
		$ChangedItems{$NewsID{$_}} = 1;
	}
	# The End
}

sub Temporal_MakeDate {
	my ($adate,$atime,$fulltime) = @_;
	$fulltime ||= time;
	BasicDateVars($fulltime);
	my $i;
	my ($aday, $amon, $ayear) = split(/\D+/, $adate);
	my ($ahour, $amin, $asec) = split(/\D+/, $atime);
	$ahour = ( $ahour =~ m~\A\d+\Z~ ? int($ahour) : $Hour ) || 0;
	$amin = ( $amin =~ m~\A\d+\Z~ ? int($amin) : $Minute ) || 0;
	$asec = ( $asec =~ m~\A\d+\Z~ ? int($asec) : $Second ) || 0;
	$amon = int($amon) || $ActualMonth;
	$amon--;
	$aday = int($aday) || $Month_Day;
	$ayear = int($ayear) || $Year;
	$ayear = $ayear - 1900;
	$fulltime = 0;
	eval {
		$fulltime = timelocal($asec,$amin,$ahour, $aday, $amon, $ayear);
	};
	if ($@) { 
		NPdie("Invalid date format: $adate - parsed as (sec: $asec, min: $amin, hour: $ahour, day: $aday, month: $months{$amon}, year: $ayear). Reason: $@");  
	}
	return $fulltime;
}
1;
